UNIT LRLIntroduction;

INTERFACE

USES DOSFileAccess,LRLRoutines,LRLSprites,StrUnit;

PROCEDURE LRLIntro;

IMPLEMENTATION

CONST
	IntroText: ARRAY[1..18] OF STRING[44] =
	('Lode Runner LIVE. FREEWARE Version 1.0',
	'Copyright (c) 1995 Aleksey V. Vaneev',
	'',
	'Greetings to everybody who like',
	'pepsi, multi-ch music, 3dstudio, asm,',
	'pascal, good samples, free kilobytes,',
	'and... : )',
	'',
	'"Silence During Play"? Heh... : )',
	'',
	'Sounds and music may appear in next version!',
	'',
	'Send comments to Aleksey V. Vaneev',
	'2:5003/15@FidoNet',
	'ikomi@glas.apc.org',
	'',
	'',
	''
	);

VAR
	RefreshDelay: WORD;
	RefreshRemain: WORD;
	TimeToRefresh: BOOLEAN;
	OldTimer: POINTER;

PROCEDURE RefreshRunner;
INTERRUPT;
ASSEMBLER;
ASM
	DEC RefreshRemain
	JNZ @DoTimer

	MOV AX,RefreshDelay
	MOV RefreshRemain,AX
	MOV TimeToRefresh,-1

@DoTimer:
	PUSHF
	CALL OldTimer
END;

PROCEDURE LRLIntro;
VAR
	i,j,l: INTEGER;
	count: WORD;
	k: WORD;
	MainScreen: POINTER;
BEGIN
	RefreshDelay:=1;
	RefreshRemain:=1;
	GETMEM(MainScreen,64004);
	DFAFilePositionSet(ImageFile,LRLImagesFilePosition+7940,DFASeekFromStart);
	DFAFileRead(ImageFile,MainScreen^,64004,k);
	Palette256Set(LRLMenuPalette^);
	ImageFill(LRLFontBuffer^,320,55,0);
	ImageClear(LRLScreen^);
	FOR i:=-50 TO 4 DO BEGIN
		ImagePut(LRLScreen^,LRLFontBuffer^,0,0,0,0,319,199);
		ImagePut(LRLScreen^,LRLLogo^,3,i,0,0,319,199);
		RetraceWait;
		ScreenApply(LRLScreen^);
		IF Keypressed THEN BEGIN
			Readkey;
			FREEMEM(MainScreen,64004);
			EXIT;
		END;
	END;
	ImageFill(LRLFontBuffer^,320,55,0);
	FOR i:=0 TO 10 DO BEGIN
		FOR k:=0 TO 20 DO BEGIN
			FOR j:=0 TO 16 DO
				ImagePutTransparent(LRLScreen^,MainScreen^,0,0,j*20-10-i,k*20-10-i,j*20-10+i,k*20-10+i);
		END;
		RetraceWait;
		FOR k:=1 TO 40000 DO;
		RetraceWait;
		ImagePut(LRLScreen^,LRLFontBuffer^,0,182,0,0,319,199);
		ScreenApply(LRLScreen^);
		IF Keypressed THEN BEGIN
			Readkey;
			FREEMEM(MainScreen,64004);
			EXIT;
		END;
	END;
	OldTimer:=SetInterrupt($8,@RefreshRunner);
	count:=1;
	k:=1;
	REPEAT
		IF TimeToRefresh THEN BEGIN
			INC(count);
			TimeToRefresh:=FALSE;
		END;
		IF count>=65 THEN BEGIN
			ImageStringGet(CharReplicate(' ',40)+IntroText[k]+CharReplicate(' ',40),LRLFont^,LRLFontBuffer^,110);
			FOR l:=200 DOWNTO 185 DO BEGIN
				RetraceWait;
				ImagePut(LRLScreen^,LRLFontBuffer^,160-ImageSizex(LRLFontBuffer^) DIV 2,l,0,0,319,199);
				ScreenApply(LRLScreen^);
			END;
			INC(k);
			IF k=19 THEN k:=1;
			count:=0;
		END;
	UNTIL Keypressed;
	Readkey;
	SetInterrupt($8,OldTimer);
	FadeClear;
	FREEMEM(MainScreen,64004);
END;

END.